package de.intevation.flys.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Column;
import javax.persistence.SequenceGenerator;
import javax.persistence.GenerationType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.OneToMany;

import org.apache.log4j.Logger;


@Entity
@Table(name = "waterlevel_difference_column")
public class WaterlevelDifferenceColumn
implements   Serializable
{
    private static Logger logger =
        Logger.getLogger(WaterlevelDifferenceColumn.class);


    private Integer id;

    private WaterlevelDifference difference;

    private List<WaterlevelDifferenceValue> values;

    private String description;


    public WaterlevelDifferenceColumn() {
        values = new ArrayList<WaterlevelDifferenceValue>();
    }

    public WaterlevelDifferenceColumn(
        WaterlevelDifference difference,
        String               description
    ) {
        this();

        this.difference = difference;
        this.description = description;
    }


    @Id
    @SequenceGenerator(
        name           = "SEQUENCE_WATERLEVEL_DIFF_COLUMN_ID_SEQ",
        sequenceName   = "WATERLEVEL_DIFF_COLUMN_ID_SEQ",
        allocationSize = 1)
    @GeneratedValue(
        strategy  = GenerationType.SEQUENCE,
        generator = "SEQUENCE_WATERLEVEL_DIFF_COLUMN_ID_SEQ")
    @Column(name = "id")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @OneToOne
    @JoinColumn(name = "difference_id" )
    public WaterlevelDifference getDifference() {
        return difference;
    }

    public void setDifference(WaterlevelDifference difference) {
        this.difference = difference;
    }

    @Column(name = "description")
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @OneToMany
    @JoinColumn(name = "column_id")
    public List<WaterlevelDifferenceValue> getValues() {
        return values;
    }

    public void setValues(List<WaterlevelDifferenceValue> values) {
        this.values = values;
    }

    public void addValue(WaterlevelDifferenceValue value) {
        this.values.add(value);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
